## kvirc 4.2.0

=== CMakeLists.txt ===
###############################################################################
##
## KVIrc CMake global configuration file.
##
###############################################################################

###############################################################################
# GLOBAL DEFS
###############################################################################

# Name of the project
PROJECT(kvirc)

# Set conventional loops
SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

# Minimum cmake version
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)

if(POLICY CMP0017)
	cmake_policy(SET CMP0017 NEW)
endif(POLICY CMP0017)

# Check modules first in local dir
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

# Some vars
SET(PACKAGE "kvirc")
SET(NICENAME "KVIrc")
SET(VERSION_MAJOR "4")
SET(VERSION_BRANCH "4.2")
SET(VERSION_RELEASE "4.2.0")
SET(VERSION_CODENAME "Equilibrium")
# REMINDER: "Aria" is a candidate, trunk name "Quasar"

STRING(REGEX MATCH "[0-9]+$" VERSION_MINOR ${VERSION_BRANCH})


SET(CMAKE_KVIRC_VERSION_MAJOR ${VERSION_MAJOR})
SET(CMAKE_KVIRC_VERSION_BRANCH ${VERSION_BRANCH})
SET(CMAKE_KVIRC_VERSION_RELEASE ${VERSION_RELEASE})
SET(CMAKE_KVIRC_VERSION_CODENAME ${VERSION_CODENAME})
SET(CMAKE_KVIRC_BUILD_COMMAND ${CMAKE_COMMAND})
SET(CMAKE_KVIRC_BUILD_FLAGS)
SET(CMAKE_KVIRC_BUILD_SYSTEM ${CMAKE_SYSTEM})
SET(CMAKE_KVIRC_BUILD_SYSTEM_NAME ${CMAKE_SYSTEM_NAME})
SET(CMAKE_KVIRC_BUILD_SYSTEM_VERSION ${CMAKE_SYSTEM_VERSION})
SET(CMAKE_KVIRC_BUILD_CPU ${CMAKE_SYSTEM_PROCESSOR})
SET(CMAKE_KVIRC_BUILD_COMPILER ${CMAKE_CXX_COMPILER})
SET(CMAKE_KVIRC_BUILD_COMPILER_FLAGS ${CMAKE_CXX_FLAGS})

# Suffix for Linux
SET(LIB_SUFFIX
	CACHE STRING "Define suffix of directory name (32/64)"
)

# Get revision number from SVN
SET(MANUAL_REVISION
	CACHE STRING "Manually set the revision number"
)



STRING(COMPARE EQUAL "${MANUAL_REVISION}" "" MANUAL_REVISION_UNSET)
IF(MANUAL_REVISION_UNSET)
	# No manually forced revision number, gotta guess one now
	IF(EXISTS "${CMAKE_SOURCE_DIR}/.svnrevision")
		# We're in a release package created using makedist.sh, so we should include a .svnrevision file
		FILE(READ "${CMAKE_SOURCE_DIR}/.svnrevision" DISTSVNREVISION)
		STRING(STRIP "${DISTSVNREVISION}" CMAKE_KVIRC_BUILD_REVISION)
		MESSAGE(STATUS "SVN revision is ${CMAKE_KVIRC_BUILD_REVISION}")
	ELSE()
		FIND_PACKAGE(Subversion)
		IF(Subversion_FOUND)
			MESSAGE(STATUS "Found Subversion ${Subversion_VERSION_SVN}")
			
			# Subversion_WC_INFO is buggy and will croak if ran on a directory that is not checked out from svn

			# SVN info does not like .. as paths, so be sure that we use a full path
			GET_FILENAME_COMPONENT(ABS_FOLDER ${CMAKE_SOURCE_DIR} ABSOLUTE)
			EXECUTE_PROCESS(
					COMMAND ${Subversion_SVN_EXECUTABLE} info ${ABS_FOLDER}
					RESULT_VARIABLE INFO_RESULT
					OUTPUT_VARIABLE IGNORED
					ERROR_VARIABLE IGNORED
				)
			IF(INFO_RESULT EQUAL 0)
				Subversion_WC_INFO(${PROJECT_SOURCE_DIR} KVIrc) 
				IF(DEFINED KVIrc_WC_REVISION)
					SET(CMAKE_KVIRC_BUILD_REVISION ${KVIrc_WC_REVISION})
					MESSAGE(STATUS "Current revision is ${KVIrc_WC_REVISION}")
				ELSE()
					MESSAGE(STATUS "No revision number found (no clue why though).")
				ENDIF()
			ELSE()
				MESSAGE(STATUS "No revision number found (not a subversion repository).")
			ENDIF()
		ELSE()
			MESSAGE(STATUS "No revision number found (subversion not available).")
		ENDIF()
	ENDIF()

ELSE()
	# Manually forced revision number
	SET(CMAKE_KVIRC_BUILD_REVISION ${MANUAL_REVISION})
	MESSAGE(STATUS "Current revision has been manually set to ${MANUAL_REVISION}")
ENDIF()


# Simplify eventual mixed revisions and strange tweaks with letters in it
STRING(REGEX REPLACE ":[0-9a-zA-Z]+" "" CMAKE_KVIRC_BUILD_REVISION "${CMAKE_KVIRC_BUILD_REVISION}")
STRING(REGEX REPLACE "[^0-9]+" "" CMAKE_KVIRC_BUILD_REVISION "${CMAKE_KVIRC_BUILD_REVISION}")


# Set man dir
SET(MANDIR
	CACHE STRING "Define man directory starting from $CMAKE_INSTALL_PREFIX"
)

STRING(COMPARE EQUAL "${MANDIR}" "" MANDIR_UNSET)
IF(MANDIR_UNSET)
	SET(MANDIR_PREFIX "share/man")
ELSE()
	SET(MANDIR_PREFIX "man")
ENDIF()
LIST(APPEND CMAKE_KVIRC_BUILD_FLAGS MANDIR=${MANDIR_PREFIX})

# Get the build date
TRY_RUN(TEST_DID_RUN TEST_DID_COMPILE "${CMAKE_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/datetime.cpp" OUTPUT_VARIABLE TEST_BUILD_DATE)
IF(TEST_DID_COMPILE)
	STRING(REGEX MATCH "[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9] [A-Z][A-Z][A-Z]" CMAKE_KVIRC_BUILD_DATE "${TEST_BUILD_DATE}")
ELSE()
	MESSAGE(STATUS " Test datetime program failed to compile:")
	MESSAGE(STATUS " ----------------------------------------")
	MESSAGE(STATUS "${TEST_BUILD_DATE}")
	MESSAGE(STATUS " ----------------------------------------")
	SET(CMAKE_KVIRC_BUILD_DATE "ERROR ")
ENDIF()

# Set var to link with, for later use
SET(LIBS)
SET(ADDITIONAL_LINK_FLAGS)

# Install path
IF(UNIX)
	IF(APPLE)
		# MacOS X
		# Due to the special bundle structure ignore
		# the prefix eventually set by the user.
		SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/KVIrc.app)
	ELSE()
		# Linux / BSD
		IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
			#fix package build
			IF(PREFIX)
				SET(CMAKE_INSTALL_PREFIX ${PREFIX})
			ELSE()
				SET(CMAKE_INSTALL_PREFIX /usr/local)
			ENDIF()
		ENDIF()
	ENDIF()
ELSEIF(WIN32)
	SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/release)
ENDIF()
LIST(APPEND CMAKE_KVIRC_BUILD_FLAGS CMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX})


###############################################################################
#
# Release type
#
###############################################################################
OPTION(WANT_ENV_FLAGS "Don't try to set CMAKE_C(XX)_FLAGS; instead, use the ones from environment variables" OFF)

OPTION(WANT_DEBUG "Compile debug symbols" OFF)
IF(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo OR DEBUG OR WITH_DEBUG)
	SET(WANT_DEBUG ON CACHE BOOL "Compile debug symbols" FORCE)
	SET(COMPILE_DEBUG_MODE 1)
ENDIF()

OPTION(WANT_STRIP "Strip binaries (discard symbols from object files)" OFF)

IF(WANT_ENV_FLAGS)
	SET(CMAKE_BUILD_TYPE Undefined)
	SET(CMAKE_STATUS_DEBUG_SUPPORT "Environment-driven")
ELSE()
	IF(WANT_DEBUG)
		SET(WANT_STRIP OFF CACHE BOOL "Strip binaries (discard symbols from object files)" FORCE)
		SET(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
		SET(CMAKE_STATUS_DEBUG_SUPPORT "Yes")
		IF(CMAKE_COMPILER_IS_GNUCXX)
			#force gdb format of debug symbols
			SET(CMAKE_CXX_FLAGS "-O0 -ggdb -pipe --exec-charset=UTF-8 --input-charset=UTF-8 --no-implement-inlines --unit-at-a-time --fast-math")
			SET(CMAKE_C_FLAGS "-O0 -ggdb -pipe --exec-charset=UTF-8 --input-charset=UTF-8 --no-implement-inlines --unit-at-a-time --fast-math")
			INCLUDE(CheckCXXCompilerFlag)
			CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" CXX_HAS_VH_FLAG)
			CHECK_CXX_COMPILER_FLAG("-fvisibility-inlines-hidden" CXX_HAS_VIH_FLAG)
			#gcc doesn't support visibility on PE/win32
			IF(NOT MINGW)
				IF(CXX_HAS_VH_FLAG)
					SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
					SET(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
				ENDIF()
				IF(CXX_HAS_VIH_FLAG)
					SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
					SET(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
				ENDIF()
			ENDIF()
		ELSE()
			IF(MSVC)
				#CMake default options are conflicting for some modules, such as perl
				STRING(REPLACE "/RTC1" "" CMAKE_CXX_FLAGS_DEBUG_INIT ${CMAKE_CXX_FLAGS_DEBUG_INIT})
				STRING(REPLACE "/RTC1" "" CMAKE_C_FLAGS_DEBUG_INIT ${CMAKE_C_FLAGS_DEBUG_INIT})
				STRING(REPLACE "/RTC1" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
				STRING(REPLACE "/RTC1" "" CMAKE_C_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
				#this is the equivalent of -O0 -g according to msdn
				SET(CMAKE_CXX_FLAGS "/Od /Zi")
				SET(CMAKE_C_FLAGS "/Od /Zi")
			ELSE()
				SET(CMAKE_CXX_FLAGS "-O0 -g")
				SET(CMAKE_C_FLAGS "-O0 -g")
			ENDIF()
		ENDIF()
	ELSE()
		IF(WANT_STRIP)
			FIND_PROGRAM(STRIP_EXECUTABLE NAMES strip)
			IF(STRIP_EXECUTABLE)
				SET(CMAKE_STATUS_DEBUG_SUPPORT "No (Stripped)")
				SET(CMAKE_BUILD_TYPE Release-stripped CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
			ELSE()
				SET(CMAKE_STATUS_DEBUG_SUPPORT "No (Release)")
				SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
			ENDIF()
		ELSE()
			SET(CMAKE_STATUS_DEBUG_SUPPORT "No (Release)")
			SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
		ENDIF()
		IF(CMAKE_COMPILER_IS_GNUCXX)
			#force gdb options
			SET(CMAKE_CXX_FLAGS "-O3 -fomit-frame-pointer -DNDEBUG --no-enforce-eh-specs -pipe --exec-charset=UTF-8 --input-charset=UTF-8 --no-implement-inlines --unit-at-a-time --fast-math")
			SET(CMAKE_C_FLAGS "-O3 -fomit-frame-pointer -DNDEBUG --no-enforce-eh-specs -pipe --exec-charset=UTF-8 --input-charset=UTF-8 --no-implement-inlines --unit-at-a-time --fast-math")
			INCLUDE(CheckCXXCompilerFlag)
			CHECK_CXX_COMPILER_FLAG("-fvisibility-inlines-hidden" CXX_HAS_VIH_FLAG)
			#gcc doesn't support visibility on PE/win32
			IF(CXX_HAS_VIH_FLAG AND NOT MINGW)
				SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
				SET(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
			ENDIF()
		ELSE()
			IF(MSVC)
				#CMake default options are conflicting for some modules, such as perl
				STRING(REPLACE "/RTC1" "" CMAKE_CXX_FLAGS_DEBUG_INIT ${CMAKE_CXX_FLAGS_DEBUG_INIT})
				STRING(REPLACE "/RTC1" "" CMAKE_C_FLAGS_DEBUG_INIT ${CMAKE_C_FLAGS_DEBUG_INIT})
				STRING(REPLACE "/RTC1" "" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
				STRING(REPLACE "/RTC1" "" CMAKE_C_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
				SET(CMAKE_CXX_FLAGS "/Ox")
				SET(CMAKE_C_FLAGS "/Ox")
			ELSE()
				SET(CMAKE_CXX_FLAGS "-O3")
				SET(CMAKE_C_FLAGS "-O3")
			ENDIF()
		ENDIF()
	ENDIF()
ENDIF()

############################################################################
# Check for KDE4
# This has been moved to the top of CMakeLists.txt, since FindKde4 overwrite
# cmake's module search paths, forcing us to use their version of these
# modules (eg: FindOpenSSL, see bug #655)
############################################################################

OPTION(WANT_KDE4 "Whether to use KDE4 support" ON)
IF(WANT_KDE4)
	FIND_PACKAGE(KDE4)
	IF(KDE4_FOUND)
		INCLUDE_DIRECTORIES(${KDE4_INCLUDES})
		ADD_DEFINITIONS(${KDE4_DEFINITIONS})
		SET(COMPILE_KDE_SUPPORT 1)
		LIST(APPEND LIBS ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY} ${KDE4_KPARTS_LIBRARY} ${KDE4_KFILE_LIBRARY} ${KDE4_KIO_LIBRARY} ${KDE4_SOLID_LIBRARY})
		SET(CMAKE_STATUS_KDE4_SUPPORT "Yes")

		# The KDE4 cmake module has a VERY WEIRD behaviour: it adds -Wl,--no-undefined
		# to the CMAKE_MODULE_LINKER_FLAGS .. which is BAD
		STRING(REPLACE "-Wl,--no-undefined" "" CMAKE_MODULE_LINKER_FLAGS ${CMAKE_MODULE_LINKER_FLAGS})
	ELSE()
		SET(CMAKE_STATUS_KDE4_SUPPORT "Not available")
	ENDIF()
ELSE()
	SET(CMAKE_STATUS_KDE4_SUPPORT "No")
ENDIF()

###############################################################################
#
# Verbose Makefile
#
###############################################################################

OPTION(WANT_VERBOSE "Generate verbose Makefiles" OFF)
IF(WANT_VERBOSE)
	SET(CMAKE_VERBOSE_MAKEFILE ON)
	SET(CMAKE_STATUS_VERBOSE_SUPPORT "Yes")
	LIST(APPEND CMAKE_KVIRC_BUILD_FLAGS VERBOSE)
ELSE()
	SET(CMAKE_STATUS_VERBOSE_SUPPORT "No")
ENDIF()


###############################################################################
#
# Version compatibility switch: appends VERSION_MAJOR to kvirc and kvilib
#
###############################################################################

OPTION(WANT_COEXISTENCE "Append version to binaries to maintain compatibility with older versions" OFF)

=== data/CMakeLists.txt ===
# CMakeLists for data/

# Find subdirs
SUBDIRS(applnk audio config defscript deftheme helppics man msgcolors pics)

IF(APPLE)
	# MacOS X
	ADD_SUBDIRECTORY(resources_mac)
ELSEIF(WIN32)
	ADD_SUBDIRECTORY(resources_win32)
ELSEIF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(icons)
	ADD_SUBDIRECTORY(mimetypes)
	ADD_SUBDIRECTORY(protocols)
ENDIF()

=== doc/CMakeLists.txt ===
# CMakeLists for doc/

SET(license
	COPYING
	LICENSE-GPLV2
	LICENSE-GPLV3
	LICENSE-OPENSSL
)
SET(howto
	README
	FAQ
	INSTALL
	INSTALL-MacOS.txt
	INSTALL-Win32.txt
	addon.howto.txt
	firefox.hack.txt
	hackers.guide.txt
	scripting.faq.txt
	themes.howto.txt
	translations.howto.txt
	ui-style.tips.txt
)

# User documentation
IF(PERL_FOUND)

	# The userdocs target is in the normal build process and rebuilds the documentation
	# only when the revision number changes. This is useful for svn users and package users.

	# The docs target is standalone and explicitly builds the documentation (useful for developers)

	IF(DEFINED CMAKE_KVIRC_BUILD_REVISION)
		SET(USERDOCS_VERSION "${VERSION_RELEASE}.${CMAKE_KVIRC_BUILD_REVISION}")
	ELSE()
		SET(USERDOCS_VERSION "${VERSION_RELEASE}")
	ENDIF()

	SET(USERDOCS_OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/help/en/documentation.${USERDOCS_VERSION}.tag")

	ADD_CUSTOM_TARGET(userdocs ALL)
	ADD_CUSTOM_TARGET(userdocs-en DEPENDS ${USERDOCS_OUTPUT_FILE})
	ADD_DEPENDENCIES(userdocs userdocs-en)

	IF(UNIX)
		ADD_CUSTOM_COMMAND(
			OUTPUT ${USERDOCS_OUTPUT_FILE}
			COMMENT "Generating user documentation..."
			COMMAND ${PERL_EXECUTABLE} ${PROJECT_SOURCE_DIR}/admin/gendoc.pl -v ${USERDOCS_VERSION} '${CMAKE_CURRENT_BINARY_DIR}/help/en/' ${PROJECT_SOURCE_DIR}/data/doctemplates/ ${PROJECT_SOURCE_DIR}/src/
		)
		IF(APPLE)
			INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/help/ DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/help)
		ELSE()
			# Assume linux
			INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/help/ DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/help)
		ENDIF()
		ADD_CUSTOM_TARGET(
			docs
			COMMENT "Generating user documentation..."
			COMMAND ${PERL_EXECUTABLE} ${PROJECT_SOURCE_DIR}/admin/gendoc.pl -v ${USERDOCS_VERSION} '${CMAKE_CURRENT_BINARY_DIR}/help/en/' ${PROJECT_SOURCE_DIR}/data/doctemplates/ ${PROJECT_SOURCE_DIR}/src/
		)
	ELSEIF(WIN32)
		ADD_CUSTOM_COMMAND(
			OUTPUT ${USERDOCS_OUTPUT_FILE}
			COMMENT "Generating user documentation..."
			COMMAND ${PERL_EXECUTABLE} ${PROJECT_SOURCE_DIR}/admin/gendoc.pl -v ${USERDOCS_VERSION} ${CMAKE_CURRENT_BINARY_DIR}/help/en/ ${PROJECT_SOURCE_DIR}/data/doctemplates/ ${PROJECT_SOURCE_DIR}/src/
		)
		INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/help/ DESTINATION ${CMAKE_INSTALL_PREFIX}/help)	
		ADD_CUSTOM_TARGET(
			docs
			COMMENT "Generating user documentation..."
			COMMAND ${PERL_EXECUTABLE} ${PROJECT_SOURCE_DIR}/admin/gendoc.pl -v ${USERDOCS_VERSION} ${CMAKE_CURRENT_BINARY_DIR}/help/en/ ${PROJECT_SOURCE_DIR}/data/doctemplates/ ${PROJECT_SOURCE_DIR}/src/
		)
	ENDIF()

ENDIF()

# Install target
IF(UNIX)
	IF(APPLE)
		INSTALL(FILES ${license} DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/license)
		INSTALL(FILES ${howto} DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/doc)
	ELSE()
		# Assume linux
		INSTALL(FILES ${license} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/license/)
		INSTALL(FILES ${howto} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/doc/)
	ENDIF()
ELSEIF(WIN32)
	INSTALL(FILES ${license} DESTINATION ${CMAKE_INSTALL_PREFIX}/license/)
	INSTALL(FILES ${howto} DESTINATION ${CMAKE_INSTALL_PREFIX}/doc/)
ENDIF()

=== po/CMakeLists.txt ===
# CMakeLists for po/

# Find subdirs
SUBDIRS(core modules)

=== scripts/CMakeLists.txt ===
# CMakeLists for scripts/

# Find subdirs
SUBDIRS(config)

=== src/CMakeLists.txt ===
# CMakeLists for src/

IF(WIN32)
	# We need this defined when compiling with cmake
	ADD_DEFINITIONS(-DCOMPILE_USE_STANDALONE_MOC_SOURCES)
ENDIF()

# Find subdirs
SUBDIRS(kvilib kvirc modules)

=== win32build/CMakeLists.txt ===
# CMakeLists for win32build
SUBDIRS(translations)

IF(WIN32)
	#attention: nsis scripts contains ${variables} that would be replaced by cmake
        CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/KVIrc.nsi.cmake ${PROJECT_BINARY_DIR}/KVIrc.nsi @ONLY)
ENDIF()

=== data/applnk/CMakeLists.txt ===
# CMakeLists for data/applnk

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/kvirc4.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/${KVIRC_BINARYNAME}.desktop)

IF(UNIX)
	IF(APPLE)
		INSTALL(FILES
			${CMAKE_CURRENT_BINARY_DIR}/${KVIRC_BINARYNAME}.desktop
			DESTINATION
			${CMAKE_INSTALL_PREFIX}/Contents/Resources/applnk/
		)
	ELSE()
		# Assume linux
		INSTALL(FILES
			${CMAKE_CURRENT_BINARY_DIR}/${KVIRC_BINARYNAME}.desktop
			DESTINATION
			${CMAKE_INSTALL_PREFIX}/share/applications/
		)
	ENDIF()
ENDIF()

=== data/audio/CMakeLists.txt ===
# CMakeLists for data/pics


FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.wav")

IF(UNIX)
	IF(APPLE)
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/audio/)
	ELSE()
		# Assume linux
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/audio/)
	ENDIF()
ELSEIF(WIN32)
	INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/audio/)
ENDIF()

=== data/config/CMakeLists.txt ===
# CMakeLists for data/config

FILE(GLOB files "*.kvc")
LIST(APPEND ${files} "style.css")

IF(UNIX)
	IF(APPLE)
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/config/)
	ELSE()
		# Assume linux
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/config/)
	ENDIF()
ELSEIF(WIN32)
	INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/config/)
ENDIF()

=== data/defscript/CMakeLists.txt ===
# CMakeLists for data/defscript

FILE(GLOB files "*.kv?")

IF(UNIX)
	IF(APPLE)
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/Contents/Resources/defscript/)
	ELSE()
		# Assume linux
		INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kvirc/${VERSION_BRANCH}/defscript/)
	ENDIF()
ELSEIF(WIN32)
	INSTALL(FILES ${files} DESTINATION ${CMAKE_INSTALL_PREFIX}/defscript/)
ENDIF()

=== data/deftheme/CMakeLists.txt ===
# CMakeLists for data/deftheme

# Find subdirs
SUBDIRS(MinimalDark-1.0.0 Aria-1.0.0)

=== debian/changelog ===
kvirc (4:4.2.0-3) unstable; urgency=medium

  * Team upload.
  * Switch to debhelper compat level 10.
  * Fix FTBFS in C++14 mode (Closes: #811908).
  * Build with libssl1.0-dev (Closes: #828370).
  * Drop explicit Pre-Depends: multiarch-support.
  * Remove obsolete lintian overrides for menu-icon-missing and
    package-needs-versioned-debhelper-build-depends.
  * Remove the menu file.
  * Use secure Vcs-* URLs.
  * Migrate to automatic debug packages.
  * Bump Standards-Version to 3.9.8.

 -- Andrey Rahmatullin <wrar@debian.org>  Fri, 04 Nov 2016 20:03:49 +0500

kvirc (4:4.2.0-2) unstable; urgency=low

  * Upload to unstable 

 -- Mark Purcell <msp@debian.org>  Sat, 18 May 2013 19:36:33 +1000

kvirc (4:4.2.0-1) experimental; urgency=low

  [ Raúl Sánchez Siles ]
  * New upstream release.
  * Updated debhelper build-depends to better cope with multiarch.
  * Fix "must not be "Multi-Arch: same"" kvirc is Multi-Arch: foreign
    (Closes: #658058)
  * Actually provide valid -dbg package. Added 30_upstream_build-g
  * Fix "Hardening flags missing". Applying suggested changes.
    (Closes: #669189) Thanks to Simon Ruderich.

 -- Mark Purcell <msp@debian.org>  Sun, 03 Mar 2013 10:54:35 +1100

=== debian/control ===
Source: kvirc
Build-Depends: debhelper (>= 10),
 cmake (>= 2.8.4+dfsg.1-3),
 kdelibs5-dev,
 libperl-dev,
 pkg-kde-tools,
 zlib1g-dev,
 libx11-dev,
 libxrender-dev,
 libssl1.0-dev,
 libqt4-dev,
 pkg-config,
 libxss-dev,
 python-dev,
 libqtwebkit-dev
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Raúl Sánchez Siles <rasasi78@gmail.com>,
 Kai Wasserbäch <curan@debian.org>,
 Mark Purcell <msp@debian.org>
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/kvirc.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-kde/kde-extras/kvirc.git
Homepage: http://www.kvirc.de/

Package: kvirc
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libkvilib4 (= ${binary:Version}),
 kvirc-modules (= ${binary:Version}),
 kvirc-data (= ${source:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: foreign
Description: KDE-based next generation IRC client with module support
 A highly configurable graphical IRC client with an MDI interface,
 built-in scripting language, support for IRC DCC, drag & drop file
 browsing, and much more. KVIrc uses the KDE widget set, can be extended
 using its own scripting language, integrates with KDE, and supports
 custom plugins.
 .
 If you're looking for a simple and plain IRC client, KVIrc is probably the
 wrong choice as it is rather big. But if you want a highly customizable client
 you won't regret the installation.

Package: libkvilib4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: kvirc (= ${binary:Version})
Multi-Arch: same
Description: KVIrc (IRC client) base library
 A highly configurable graphical IRC client with an MDI interface,
 built-in scripting language, support for IRC DCC, drag & drop file
 browsing, and much more. KVIrc uses the KDE widget set, can be extended
 using its own scripting language, integrates with KDE, and supports
 custom plugins.
 .
 This package contains the main library of KVIrc.

Package: kvirc-modules
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: libkvilib4 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: kvirc (= ${binary:Version})
Multi-Arch: same
Description: KVIrc (IRC client) modules
 A highly configurable graphical IRC client with an MDI interface,
 built-in scripting language, support for IRC DCC, drag & drop file
 browsing, and much more. KVIrc uses the KDE widget set, can be extended
 using its own scripting language, integrates with KDE, and supports
 custom plugins.
 .
 This package contains all modules for KVIrc.

Package: kvirc-data
Architecture: all
Depends: ${misc:Depends}
Recommends: kvirc (>= ${source:Version})
Multi-Arch: foreign
Description: Data files for KVIrc
 This package contains the architecture-independent data needed by KVIrc in
 order to run, such as icons and images, language files, and shell scripts.
 It also contains complete reference guides on scripting and functions
 within KVIrc in its internal help format.

=== debian/rules ===
#! /usr/bin/make -f
#
DH_ALWAYS_EXCLUDE:=CVS:.svn:.svnignore:.hg:.hgignore

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-undefined -Wl,--as-needed

DEBVERSION = $(shell head -n 1 debian/changelog | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION = $(shell echo $(DEBVERSION) | sed -r -e 's/^.*://' -e 's/-[0-9.]*(\+b[0-9])?$$//' -e 's/.dfsg[0-9]*$$//')
REV = $(shell echo $(UPVERSION) | sed -e 's/^.*svn//' -e 's/\+rc[0-9]$$//')

# We don't install all files upstream wants to. Those files get added to
# the following variable which gives us a cleaner buildd output (idea taken
# from the mesa package).
NOT_INSTALLED := \
				usr/lib/$(DEB_HOST_MULTIARCH)/libkvilib.so \
				usr/bin/kvirc-config \
				usr/share/kvirc/4.2/license/LICENSE-GPLV2 \
				usr/share/kvirc/4.2/license/LICENSE-GPLV3 \
				usr/share/kvirc/4.2/license/LICENSE-OPENSSL \
				usr/share/pixmaps/kvirc.png # this one is installed by a symlink

override_dh_auto_configure:
	dh_auto_configure -Skde -- -DWANT_COEXISTENCE=OFF \
			-DWANT_ESD=OFF -DWANT_OSS=OFF \
			-DWANT_STRIP=OFF \
			-DMANUAL_REVISION=$(REV) \
			-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

override_dh_install:
	set -e; for file in $(NOT_INSTALLED); do rm debian/tmp/$$file; done
	dh_install --fail-missing -XCOPYING

override_dh_strip:
	dh_strip --dbgsym-migration='kvirc-dbg (<< 4:4.2.0-3~)'

%:
	dh $@ --with kde

.PHONY: override_dh_auto_configure override_dh_install override_dh_strip

## kvirc 4.9.3~git20180106%2Bdfsg

=== src/kvilib/CMakeLists.txt ===
# CMakeLists.txt for src/kvilib/

include_directories(
	config
	core
	ext
	file
	irc
	locale
	net
	system
)

# Please note that the sources have alphabetic order here

set(kvilib_SRCS
	config/KviBuildInfo.cpp
	core/KviError.cpp
	core/KviHeapObject.cpp
	core/KviMemory.cpp
	core/KviQString.cpp
	core/KviCString.cpp
	core/KviShortcut.cpp
	ext/KviCommandFormatter.cpp
	ext/KviConfigurationFile.cpp
	ext/KviCryptEngine.cpp
	ext/KviCryptEngineManager.cpp
	ext/KviDataBuffer.cpp
	ext/KviDbusAdaptor.cpp
	ext/KviDebugContext.cpp
	ext/KviMediaManager.cpp
	ext/KviMiscUtils.cpp
	ext/KviMessageTypeSettings.cpp
	ext/KviPixmap.cpp
	ext/KviPixmapUtils.cpp
	ext/KviAnimatedPixmap.cpp
	ext/KviAnimatedPixmapCache.cpp
	ext/KviNickColors.cpp
	ext/KviProxy.cpp
	ext/KviProxyDataBase.cpp
	ext/KviRegisteredChannel.cpp
	ext/KviRegisteredChannelDataBase.cpp
	ext/KviRegisteredUser.cpp
	ext/KviRegisteredUserDataBase.cpp
	ext/KviRegisteredUserGroup.cpp
	ext/KviRegisteredUserMask.cpp
	ext/KviRuntimeInfo.cpp
	ext/KviSharedFile.cpp
	ext/KviSharedFilesManager.cpp
	ext/KviStringConversion.cpp
	file/KviFile.cpp
	file/KviFileUtils.cpp
	file/KviPackageIOEngine.cpp
	file/KviPackageReader.cpp
	file/KviPackageWriter.cpp
	irc/KviAvatar.cpp
	irc/KviAvatarCache.cpp
	irc/KviControlCodes.cpp
	irc/KviIdentityProfile.cpp
	irc/KviIdentityProfileSet.cpp
	irc/KviIrcMask.cpp
	irc/KviIrcNetwork.cpp
	irc/KviIrcServer.cpp
	irc/KviIrcServerDataBase.cpp
	irc/KviIrcUserDataBase.cpp
	irc/KviIrcUserEntry.cpp
	irc/KviNickServRule.cpp
	irc/KviNickServRuleSet.cpp
	irc/KviUserIdentity.cpp
	irc/KviUserIdentityManager.cpp
	locale/KviLocale.cpp
	locale/KviMessageCatalogue.cpp
	locale/KviTranslationEntry.cpp
	locale/KviTranslator.cpp
	net/KviDnsResolver.cpp
	net/KviHttpRequest.cpp
	net/KviNetUtils.cpp
	net/KviNetworkAccessManager.cpp
	net/KviSASL.cpp
	net/kvi_socket.cpp
	net/KviSSL.cpp
	net/KviUrl.cpp
	system/KviEnvironment.cpp
	system/KviSignalHandler.cpp
	system/KviThread.cpp
	system/KviTimeUtils.cpp
	tal/KviTalApplication.cpp
	tal/KviTalFileDialog.cpp
	tal/KviTalGroupBox.cpp
	tal/KviTalHBox.cpp
	tal/KviTalIconAndRichTextItemDelegate.cpp
	tal/KviTalListWidget.cpp
	tal/KviTalMainWindow.cpp
	tal/KviTalMenuBar.cpp
	tal/KviTalSplitter.cpp
	tal/KviTalTabDialog.cpp
	tal/KviTalTableWidget.cpp
	tal/KviTalToolTip.cpp
	tal/KviTalVBox.cpp
	tal/KviTalWizard.cpp
)

if(NOT DEFINED COMPILE_DISABLE_OGG_THEORA)
	list(APPEND kvilib_SRCS
		ext/KviOggTheoraDecoder.cpp
		ext/KviOggTheoraEncoder.cpp
	)
endif()

# Create library
if(WANT_COEXISTENCE)
	set(KVILIB_BINARYNAME kvilib${VERSION_MAJOR})
else()
	set(KVILIB_BINARYNAME kvilib)
endif()

#we need this defined when mingw will compile moc files
if(WIN32)
	add_definitions(-D_WANT_KVILIB_)
endif()

if(MSVC)
	list(APPEND LIBS ws2_32.lib)
endif()

if(MINGW)
	list(APPEND LIBS -lws2_32)
endif()

add_library(${KVILIB_BINARYNAME} SHARED ${kvilib_SRCS} ${kvilib_MOC_SRCS})
target_link_libraries(${KVILIB_BINARYNAME} ${LIBS})

# Enable C++11
set_property(TARGET ${KVILIB_BINARYNAME} PROPERTY CXX_STANDARD 11)
set_property(TARGET ${KVILIB_BINARYNAME} PROPERTY CXX_STANDARD_REQUIRED ON)


if(Qt5Widgets_FOUND)
	qt5_use_modules(${KVILIB_BINARYNAME} ${qt5_kvirc_modules})
endif()

set_target_properties(${KVILIB_BINARYNAME} PROPERTIES VERSION ${VERSION_RELEASE} SOVERSION ${VERSION_MAJOR} LINK_FLAGS "${ADDITIONAL_LINK_FLAGS}")

if(WANT_STRIP)
	IF(APPLE)
		add_custom_command(
			TARGET ${KVILIB_BINARYNAME}
			POST_BUILD
			COMMAND ${STRIP_EXECUTABLE} -x $<TARGET_FILE:${KVILIB_BINARYNAME}>
		)
	ELSE()
		add_custom_command(
			TARGET ${KVILIB_BINARYNAME}
			POST_BUILD
			COMMAND ${STRIP_EXECUTABLE} -s $<TARGET_FILE:${KVILIB_BINARYNAME}>
		)
	ENDIF()
endif()

# Installation directives

if(CYGWIN)
	install(TARGETS ${KVILIB_BINARYNAME} LIBRARY DESTINATION "${KVIRC_LIB_PATH}" RUNTIME DESTINATION "${KVIRC_LIB_PATH}")
elseif(UNIX)
	install(TARGETS ${KVILIB_BINARYNAME} LIBRARY DESTINATION "${KVIRC_LIB_PATH}")
elseif(WIN32)
	# For DLL platforms the DLL part of a shared library is treated as a RUNTIME target and the corresponding import library is treated as an ARCHIVE target
	install(TARGETS ${KVILIB_BINARYNAME} RUNTIME DESTINATION "${KVIRC_LIB_PATH}")
	install(FILES $<TARGET_PDB_FILE:${KVILIB_BINARYNAME}> DESTINATION ${KVIRC_LIB_PATH} OPTIONAL)
endif()

=== src/modules/mircimport/CMakeLists.txt ===
# CMakeLists for src/modules/mircimport

subdirs(caps pics)



set(kvimircimport_SRCS
	libkvimircimport.cpp
)

set(kvi_module_name kvimircimport)
include(${CMAKE_SOURCE_DIR}/cmake/module.rules.txt)

=== src/modules/url/CMakeLists.txt ===
# CMakeLists for src/modules/url

set(kviurl_SRCS
	libkviurl.cpp
)

set(kvi_module_name kviurl)
include(${CMAKE_SOURCE_DIR}/cmake/module.rules.txt)
